// utility functions for bioinformatics
#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include <stdexcept>
#include <sys/time.h>
#include <sys/types.h>



#include "utils.h"
using namespace std;


// test if a file is readable
// return value : true if readable ; false if not
bool IsFileReadable( string file )
{
	ifstream fichier( file.c_str() );
	return !fichier.fail();
}

// display a time lenth in µs
// return value : void
void ExecMeasure( struct timeval begin , struct timeval end , string operation )
{
	cerr << "Execution time for operation : " << operation << " : "  << end.tv_usec - begin.tv_usec << " µs"  << endl;
}


int string_to_int( string incomingStr )
{
	istringstream isstmp( incomingStr );
	int i;
	isstmp >> i;
	return i;
}

string double_to_string( double incoming )
{
	string result;
	ostringstream oss;
	oss << incoming;
	result = oss.str();
	return result;
}


string int_to_string( int incoming )
{
	string result;
	ostringstream oss;
	oss << incoming;
	result = oss.str();
	return result;
}

string pyReplace( string incoming , string pattern , string replacement )
{
	while (incoming.rfind( pattern ) != string::npos )
	{
		int n = incoming.rfind( pattern );
		int l = pattern.length();

		incoming.replace( n , l , replacement );
	}
	return incoming;
}

string char_to_string(char incoming)
{
	string s;
	stringstream ss;
	ss << incoming;
	ss >> s;
	return s;
}
















char checkBase(char incoming )
{
	if( incoming == 'c' )
	{
		return 'C';
	}
	if( incoming == 't' )
	{
		return 'T';
	}
	if( incoming == 'a' )
	{
		return 'A';
	}
	if( incoming == 'g' )
	{
		return 'G';
	}
	if( incoming == 'n' )
	{
		return 'N';
	}
	if( incoming == 'C' )
	{
		return 'C';
	}
	if( incoming == 'T' )
	{
		return 'T';
	}
	if( incoming == 'A' )
	{
		return 'A';
	}
	if( incoming == 'G' )
	{
		return 'G';
	}
	if( incoming == 'N' )
	{
		return 'N';
	}
	return 'N';
}
